
%define name nvidia_legacy
%define nversion 1.0
%define nrelease 7184
%define version %nrelease

# pkg0: plain archive
# pkg1: + precompiled modules
# pkg2: + 32bit compatibility libraries
%define x86pkg_rel pkg0
%define x86_64pkg_rel pkg2

%define distsuffix plf

%define rel 4
%define release %mkrel %rel

%define major 1
%define module_name nvidia

%ifarch %ix86
%define packagedir NVIDIA-Linux-x86-%{nversion}-%{nrelease}-%{x86pkg_rel}
%endif
%ifarch x86_64
%define packagedir NVIDIA-Linux-x86_64-%{nversion}-%{nrelease}-%{x86_64pkg_rel}
%endif


%if %{mdkversion} <= 200600
%define xorgdir %{_prefix}/X11R6/%{_lib}
%define xvmcdir %{_prefix}/X11R6/%{_lib}
%define ldsoconfgldir %{_sysconfdir}/ld.so.conf.d
%define nvidiadriversdir %{xorgdir}/modules/drivers
%define nvidiaglxdir %{xorgdir}/modules/extensions/nvidia
%else
%define xorgdir %{_libdir}/xorg
%define xvmcdir %{_libdir}
%define ldsoconfgldir %{_sysconfdir}/ld.so.conf.d/GL
%define nvidiadriversdir %{xorgdir}/modules/drivers/%{name}
%define nvidiaglxdir %{xorgdir}/modules/extensions/%{name}
%endif

# other packages should not require any libraries from these pkgs
# if they do, either they're broken or the lib needs to be split out
%define _provides_exceptions \\.so
%define common_requires_exceptions libGLcore\\.so\\|libnvidia-tls\\.so

%ifarch x86_64
# we catch out 32bit deps
%define _requires_exceptions %common_requires_exceptions\\|lib.*so.[0-9]*\\(([^)]\\+)\\)\\{0,1\\}$
%else
%define _requires_exceptions %common_requires_exceptions
%endif

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	NVIDIA proprietary X.org driver and libraries for old cards
License:	Freeware
Source0: 	ftp://download.nvidia.com/XFree86/Linux-x86/%{nversion}-%{nrelease}/NVIDIA-Linux-x86-%{nversion}-%{nrelease}-%{x86pkg_rel}.run
Source1: 	ftp://download.nvidia.com/XFree86/Linux-x86_64/%{nversion}-%{nrelease}/NVIDIA-Linux-x86_64-%{nversion}-%{nrelease}-%{x86_64pkg_rel}.run
URL:		http://www.nvidia.com/object/unix.html
Group:		System/Kernel and hardware
ExclusiveArch:	%ix86 x86_64
Buildroot:	%{_tmppath}/%{name}-root
BuildRequires:	ImageMagick
Requires:	dkms-%{name} = %{version}
%if %{mdkversion} >= 200700
Requires:	x11-server-common
Requires:	drakxtools-backend >= 10.4.75
Requires(post):	update-alternatives
Requires(postun): update-alternatives
%endif
Provides:	NVIDIA_GLX
Conflicts:	nvidia
Provides:	%{name}-xorg = %{version}-%{release}
Obsoletes:	%{name}-xorg
Provides:	%mklibname nvidia_legacy-xorg 1
Obsoletes:	%mklibname nvidia_legacy-xorg 1
%ifarch x86_64
Provides:	libnvidia_legacy-xorg1
Obsoletes:	libnvidia_legacy-xorg1
%endif

%description
NVIDIA proprietary X.org graphics driver, related libraries and
configuration tools for old NVIDIA video cards. Supported products
are TNT2 based cards, Vanta based cards, original Quadro based
cards, Quadro2 Pro/EX based cards, GeForce 256/DDR based cards and
GeForce2 GTS/Pro/Ti/Ultra based cards. For newer cards please use
the drivers provided in the nvidia package instead.

You should install this package if you want to enable the NVIDIA
hardware OpenGL acceleration for those older cards.

NOTE: This PLF provided NVIDIA driver must be configured differently
than the one available from NVIDIA, see README.install.urpmi for
details.

You can reconfigure X to use the new NVIDIA driver automatically
(this is usually not necessary if you're upgrading from another PLF
or Club-provided NVIDIA driver):
1. Run XFdrake as root.
2. Go to the Graphics Card list.
3. Select your card (it is usually already autoselected).
4. Answer any questions asked and then quit.

This package is in PLF for its non-free license.

%package -n	dkms-%{name}
Summary:	NVIDIA kernel module for old NVIDIA video cards
Group:		System/Kernel and hardware
Requires:	dkms
Requires(post):	dkms
Requires(preun): dkms
Conflicts:	dkms-nvidia
Requires:	%{name} = %{version}

%description -n dkms-%{name}
NVIDIA kernel module for old NVIDIA video cards. This is to be used
with the %name package.

This package is in PLF for its non-free license.

%package	devel
Summary:	NVIDIA XvMC development library and OpenGL headers for old cards
Group:		System/Kernel and hardware
Requires:	%{name} = %{version}
Provides:	%mklibname nvidia_legacy-xorg 1 -d
Obsoletes:	%mklibname nvidia_legacy-xorg 1 -d
Conflicts:	nvidia-devel
%ifarch x86_64
Provides:	libnvidia_legacy-xorg1-devel
Obsoletes:	libnvidia_legacy-xorg1-devel
%endif

%description devel
NVIDIA XvMC static development library and OpenGL headers for old
NVIDIA video cards. This package is not required for anything, it is
just provided for completeness.

This package is in PLF for its non-free license.

%prep
%setup -T -c
%ifarch %ix86
sh %{SOURCE0} --extract-only
%endif
%ifarch x86_64
sh %{SOURCE1} --extract-only
%endif
rm -rf %{packagedir}/usr/src/nv/precompiled

cat > README.install.urpmi <<EOF
IMPORTANT NOTE: This PLF provided NVIDIA driver must be configured differently
than the one available from NVIDIA, so please follow the instructions below:

If you are upgrading from a Mandriva Club or PLF provided NVIDIA
driver, reconfiguring is usually unnecessary.

You can reconfigure X to use the new NVIDIA driver either automatically:
1. Run XFdrake as root.
2. Go to the Graphics Card list.
3. Select your card (it is usually already autoselected).
4. Answer any questions asked and then quit.

OR you can do it manually by editing %{_sysconfdir}/X11/xorg.conf:
1. Change the Driver to "nvidia" in the Device section.
2. Remove any Load "glx" lines from the Module section.
3. Add the following line to the Module section:
Load "%{nvidiaglxdir}/libglx.so"
%if %mdkversion >= 200700
4. Run "update-alternatives --config gl_conf" and select nvidia_legacy.conf.
%endif
EOF

%install
rm -rf %{buildroot}

# OpenGL headers
install -d -m755 %{buildroot}%{_includedir}/nvidia
cp -a %{packagedir}/usr/include/* %{buildroot}%{_includedir}/nvidia

# binaries
install -d -m755 %{buildroot}%{_bindir}
install -m755 %{packagedir}/usr/bin/nvidia-settings %{buildroot}/%{_bindir}
install -m755 %{packagedir}/usr/bin/nvidia-bug-report.sh %{buildroot}/%{_bindir}

# dkms
install -d -m755 %{buildroot}/usr/src/%{name}-%{version}-%{release}
cp -a  %{packagedir}/usr/src/nv/* %{buildroot}/usr/src/%{name}-%{version}-%{release}
# not required, but rpmlint complains otherwise:
chmod 0755 %{buildroot}/usr/src/%{name}-%{version}-%{release}/conftest.sh

# XvMC libraries
install -d -m755 %{buildroot}%{xvmcdir}
install -m755 %{packagedir}/usr/X11R6/lib/libXvMCNVIDIA.a %{buildroot}%{xvmcdir}
install -m755 %{packagedir}/usr/X11R6/lib/libXvMCNVIDIA.so.%{nversion}.%{nrelease} %{buildroot}%{xvmcdir}
ln -s libXvMCNVIDIA.so.%{nversion}.%{nrelease} %{buildroot}%{xvmcdir}/libXvMCNVIDIA_dynamic.so.%{major}

# nvidia_drv
install -d -m755 %{buildroot}%{nvidiadriversdir}
install -m755 %{packagedir}/usr/X11R6/lib/modules/drivers/nvidia_drv.so %{buildroot}%{nvidiadriversdir}

# libglx.so
install -d -m755 %{buildroot}%{nvidiaglxdir}
install -m755 %{packagedir}/usr/X11R6/lib/modules/extensions/libglx.so.%{nversion}.%{nrelease} %{buildroot}%{nvidiaglxdir}
ln -s libglx.so.%{nversion}.%{nrelease} %{buildroot}%{nvidiaglxdir}/libglx.so

# GL libraries
install -d -m755 %{buildroot}%{_libdir}/nvidia
install -m755 %{packagedir}/usr/lib/libGL.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/nvidia
install -m755 %{packagedir}/usr/lib/libGLcore.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/nvidia
install -m644 %{packagedir}/usr/lib/libGL.la %{buildroot}%{_libdir}/nvidia
perl -pi -e 's,__LIBGL_PATH__,%{_libdir}/nvidia,' %{buildroot}%{_libdir}/nvidia/libGL.la
ln -s libGL.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/nvidia/libGL.so.%{major}
ln -s libGL.so.%{major} %{buildroot}%{_libdir}/nvidia/libGL.so
ln -s libGLcore.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/nvidia/libGLcore.so.%{major}
%ifarch x86_64
install -d -m755 %{buildroot}%{_prefix}/lib/nvidia
install -m755 %{packagedir}/usr/lib32/libGL.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/nvidia
install -m755 %{packagedir}/usr/lib32/libGLcore.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/nvidia
install -m644 %{packagedir}/usr/lib32/libGL.la %{buildroot}%{_prefix}/lib/nvidia
perl -pi -e 's,__LIBGL_PATH__,%{_prefix}/lib/nvidia,' %{buildroot}%{_prefix}/lib/nvidia/libGL.la
ln -s libGL.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/nvidia/libGL.so.%{major}
ln -s libGL.so.%{major} %{buildroot}%{_prefix}/lib/nvidia/libGL.so
ln -s libGLcore.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/nvidia/libGLcore.so.%{major}
%endif

# other libraries
install -d -m755 %{buildroot}%{_libdir}/tls
install -m755 %{packagedir}/usr/lib/libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}
install -m755 %{packagedir}/usr/lib/tls/libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/tls
ln -s libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/libnvidia-tls.so.%{major}
ln -s libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_libdir}/tls/libnvidia-tls.so.%{major}
%ifarch x86_64
install -d -m755 %{buildroot}%{_prefix}/lib/tls
install -m755 %{packagedir}/usr/lib32/libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib
install -m755 %{packagedir}/usr/lib32/tls/libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/tls
ln -s libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/libnvidia-tls.so.%{major}
ln -s libnvidia-tls.so.%{nversion}.%{nrelease} %{buildroot}%{_prefix}/lib/tls/libnvidia-tls.so.%{major}
%endif

# ld.so.conf.d
install -d -m755 %{buildroot}%{ldsoconfgldir}
echo "%{_libdir}/nvidia" > %{buildroot}%{ldsoconfgldir}/%{name}.conf
%ifarch x86_64
echo "%{_prefix}/lib/nvidia" >> %{buildroot}%{ldsoconfgldir}/%{name}.conf
%endif

# XvMCConfig
install -d m755 %{buildroot}%{_sysconfdir}/X11
echo "libXvMCNVIDIA_dynamic.so.%{major}" > %{buildroot}%{_sysconfdir}/X11/XvMCConfig

# menus
install -d -m755 %buildroot/%{_menudir}
cat <<EOF >%buildroot/%{_menudir}/%name
?package(%{name}):command="%{_bindir}/nvidia-settings" \
                  icon=nvidia-settings.png \
                  needs="x11" \
                  section="System/Configuration/Hardware" \
                  title="NVIDIA Settings" \
                  longtitle="Configure NVIDIA X driver" \
                  xdg="true"
EOF

install -d -m755 %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-nvidia-settings.desktop <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=NVIDIA Settings
Comment=Configure NVIDIA X driver
Exec=%{_bindir}/nvidia-settings
Icon=nvidia-settings
Terminal=false
Type=Application
Categories=Settings;HardwareSettings;X-MandrivaLinux-System-Configuration;
EOF

# icons
install -d -m755 %buildroot/%{_miconsdir} %buildroot/%{_iconsdir} %buildroot/%{_liconsdir}
convert %{packagedir}/usr/share/pixmaps/nvidia-settings.png -resize 16x16 %buildroot/%{_miconsdir}/nvidia-settings.png
convert %{packagedir}/usr/share/pixmaps/nvidia-settings.png -resize 32x32 %buildroot/%{_iconsdir}/nvidia-settings.png
install -m644 %{packagedir}/usr/share/pixmaps/nvidia-settings.png %buildroot/%{_liconsdir}/nvidia-settings.png

# dkms
cat > %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{name}"
PACKAGE_VERSION="%{version}-%{release}"
DEST_MODULE_LOCATION[0]="/kernel/drivers/video"
BUILT_MODULE_NAME[0]="%{module_name}"
MAKE[0]="make -f makefile KERNEL_SOURCES=\${kernel_source_dir}; make -f Makefile SYSSRC=\${kernel_source_dir} module"
AUTOINSTALL="YES"
EOF

%clean
rm -rf %{buildroot}

# We look for non-rpm installation and uninstall it
%pre
if [[ -x /usr/bin/nvidia-installer ]]; then
	/usr/bin/nvidia-installer --uninstall -s &>/dev/null || true
	rm -f /usr/bin/nvidia-installer
fi

# Using posttrans fixes upgrade (rpm removed
# %{xorgdir}/modules/drivers/nvidia_drv.so after the script had run)
%posttrans
%if %mdkversion >= 200700
# We do the nvidia_drv.so only because mandriva does, as our nvidia and
# nvidia_legacy fully conflict with each other for the time being.
# Mandriva has priority 100, but I think it's better to have a priority
# above Mesa, which is 500.
%{_sbindir}/update-alternatives \
	--install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{ldsoconfgldir}/%{name}.conf 700 \
	--slave %{xorgdir}/modules/drivers/nvidia_drv.so nvidia_drv %{nvidiadriversdir}/nvidia_drv.so
# Override from manual mode in case of file absence
if [ ! -f %{_sysconfdir}/ld.so.conf.d/GL.conf ]; then
	%{_sbindir}/update-alternatives --auto gl_conf
fi
%endif
/sbin/ldconfig
%{update_menus}

%postun
%if %mdkversion >= 200700
# We check file instead of $0 to allow easy migration to another scheme later
if [ ! -f %{ldsoconfgldir}/%{name}.conf ]; then
	%{_sbindir}/update-alternatives --remove gl_conf %{ldsoconfgldir}/%{name}.conf
# Override from manual mode in case of file absence
	if [ ! -f %{_sysconfdir}/ld.so.conf.d/GL.conf ]; then
		%{_sbindir}/update-alternatives --auto gl_conf
	fi
fi
%endif
/sbin/ldconfig
%{clean_menus}

%post -n dkms-%{name}
dkms add     -m %{name} -v %{version}-%{release} --rpm_safe_upgrade
dkms build   -m %{name} -v %{version}-%{release} --rpm_safe_upgrade
dkms install -m %{name} -v %{version}-%{release} --rpm_safe_upgrade

# rmmod any old driver if present and not in use (e.g. by X)
rmmod %{module_name} > /dev/null 2>&1 || true

%preun -n dkms-%{name}
dkms remove -m %{name} -v %{version}-%{release} --all --rpm_safe_upgrade

%files
%defattr(-,root,root)
%doc %{packagedir}/usr/share/doc/NVIDIA_Changelog
%doc %{packagedir}/usr/share/doc/nvidia-settings-user-guide.txt
%doc %{packagedir}/usr/share/doc/README
%doc %{packagedir}/usr/share/doc/XF86Config.sample
%doc %{packagedir}/LICENSE
%doc README.install.urpmi
%config(noreplace) %{_sysconfdir}/X11/XvMCConfig
%{ldsoconfgldir}/%{name}.conf
%{_bindir}/nvidia-settings
%{_bindir}/nvidia-bug-report.sh
%if %mdkversion >= 200700
%dir %{nvidiadriversdir}
%endif
%{nvidiadriversdir}/nvidia_drv.so
%dir %{nvidiaglxdir}
%{nvidiaglxdir}/libglx.so*
%{_miconsdir}/nvidia-settings.png
%{_iconsdir}/nvidia-settings.png
%{_liconsdir}/nvidia-settings.png
%{_menudir}/%{name}
%{_datadir}/applications/mandriva-nvidia-settings.desktop
%dir %{_libdir}/nvidia
%{_libdir}/nvidia/*.so.*
%{_libdir}/libnvidia*.so.*
%dir %{_libdir}/tls
%{_libdir}/tls/*.so.*
%{xvmcdir}/libXvMC*.so.*
%ifarch x86_64
%dir %{_prefix}/lib/nvidia
%{_prefix}/lib/nvidia/*.so.*
%{_prefix}/lib/*.so.*
%dir %{_prefix}/lib/tls
%{_prefix}/lib/tls/*.so.*
%endif

%files devel
%defattr(-,root,root)
%doc %{packagedir}/LICENSE
%{_includedir}/nvidia
%{xvmcdir}/libXvMCNVIDIA.a
%{_libdir}/nvidia/*.so
%{_libdir}/nvidia/*.la
%ifarch x86_64
%{_prefix}/lib/nvidia/*.la
%{_prefix}/lib/nvidia/*.so
%endif

%files -n dkms-%{name}
%defattr(-,root,root)
%doc %{packagedir}/LICENSE
/usr/src/%{name}-%{version}-%{release}

%changelog
* Sun Sep 24 2006 Anssi Hannula <anssi@zarb.org> 7184-4plf2007.0
- raise alternatives priority on 2007.0
- make sure gl_conf is not in invalid state after remove on 2007.0
- update doc in README.install.urpmi
- use nvidia_legacy/ for glx.so only on 2007.0
- fix stale symlink check of gl_conf on 2007.0

* Sat Sep 23 2006 Anssi Hannula <anssi@zarb.org> 7184-3plf2007.0
- fix upgrade

* Thu Sep 21 2006 Anssi Hannula <anssi@zarb.org> 7184-2plf2007.0
- use alternatives for 2007.0
- drop the pre-6.9 nvidia_drv.o
- provide /etc/X11/XvMCConfig
- add doc to -devel and dkms pkgs
- move glx.so from nvidia/ to nvidia_legacy/
- update doc in description and README.install.urpmi
- standardize PLF reason

* Thu Sep 14 2006 Anssi Hannula <anssi@zarb.org> 7184-1plf2007.0
- 7184
- fix menu entry

* Sat Jul 22 2006 Anssi Hannula <anssi@zarb.org> 7182-4plf2007.0
- fix libdir in libGL.la (João Xavier)
- don't require drakxtools not available on 2006.0 official (#133)

* Mon Jul 17 2006 Anssi Hannula <anssi@zarb.org> 7182-3plf2007.0
- fail silently while uninstalling previous non-rpm installation

* Sun Jul 16 2006 Anssi Hannula <anssi@zarb.org> 7182-2plf2007.0
- merge to a new three-package packaging scheme
  * dkms-nvidia_legacy: kernel module
  * nvidia_legacy: X.org driver and libraries
  * nvidia_legacy-devel: development libraries and headers

* Mon Jun 26 2006 Anssi Hannula <anssi@zarb.org> 7182-1plf2007.0
- 7182
- drop patches, upstream
- use provided icon
- xdg menu
- fix %%post so that the module is actually installed

* Wed Jun 14 2006 Anssi Hannula <anssi@zarb.org> 7174-8plf2007.0
- patch5: fix conftest.sh for new kernels
- fix missing backslashes from _provides_exceptions

* Sat Jun 10 2006 Anssi Hannula <anssi@zarb.org> 7174-7plf2007.0
- drop unnecessary provides
- add libGL to _provides_exceptions

* Mon Jun 05 2006 Anssi Hannula <anssi@zarb.org> 7174-6plf
- requires x11-server-common on cooker

* Wed May 24 2006 Anssi Hannula <anssi@zarb.org> 7174-5plf
- fix paths for xorg 7.0
- do not modprobe in %%post

* Fri Apr  7 2006 Anssi Hannula <anssi@zarb.org> 7174-4plf
- add nvidia conflicts to library packages too
- add requires_exceptions so that urpmi doesn't offer the newer nvidia

* Mon Jan  2 2006 Anssi Hannula <anssi@zarb.org> 7174-3plf
- requires strictly the correct library

* Thu Dec 29 2005 Anssi Hannula <anssi@zarb.org> 7174-2plf
- fix description typos
- dkms-nvidia_legacy requires nvidia_legacy-xorg
- nvidia_legacy-xorg obsoletes nvidia_legacy

* Sun Dec 25 2005 Anssi Hannula <anssi@zarb.org> 7174-1plf
- initial PLF release based on nvidia.spec

